<p align="center"> 
  <br/>  
  <a href="https://opensource.org/license/agpl-v3"><img src="https://img.shields.io/badge/License-AGPL_v3-blue.svg?color=3F51B5&style=for-the-badge&label=License&logoColor=000000&labelColor=ececec" alt="License: AGPLv3"></a>
  <a href="https://discord.immich.app">
    <img src="https://img.shields.io/discord/979116623879368755.svg?label=Discord&logo=Discord&style=for-the-badge&logoColor=000000&labelColor=ececec" atl="Discord"/>
  </a>
  <br/>  
  <br/>   
</p>

<p align="center">
<img src="../design/immich-logo-stacked-light.svg" width="300" title="Login With Custom URL">
</p>
<h3 align="center">Immich - Soluzione self-hosted ad alte prestazioni per backup di foto e video</h3>
<br/>
<a href="https://immich.app">
<img src="../design/immich-screenshots.png" title="Main Screenshot">
</a>
<br/>
<p align="center">
  <a href="../README.md">English</a>
  <a href="README_ca_ES.md">Català</a>
  <a href="README_es_ES.md">Español</a>
  <a href="README_fr_FR.md">Français</a>
  <a href="README_ja_JP.md">日本語</a>
  <a href="README_ko_KR.md">한국어</a>
  <a href="README_de_DE.md">Deutsch</a>
  <a href="README_nl_NL.md">Nederlands</a>
  <a href="README_tr_TR.md">Türkçe</a>
  <a href="README_zh_CN.md">中文</a>
  <a href="README_uk_UA.md">Українська</a>
  <a href="README_ru_RU.md">Русский</a>
  <a href="README_pt_BR.md">Português Brasileiro</a>
  <a href="README_sv_SE.md">Svenska</a>
  <a href="README_ar_JO.md">العربية</a>
  <a href="README_th_TH.md">ภาษาไทย</a>
</p>

## Declino di responsabilità

- ⚠️ Il progetto è in una fase **molto intensa** di sviluppo.
- ⚠️ Possibilità di bug e cambiamenti rilevanti.
- ⚠️ **Non utilizzare l'app come unico salvataggio delle tue foto e dei tuoi video.**
- ⚠️ Utilizza sempre una tecnica [3-2-1](https://www.backblaze.com/blog/the-3-2-1-backup-strategy/) di backup per le foto e i video a cui tieni!

## Contenuto

- [Documentazione Ufficiale](https://immich.app/docs)
- [Roadmap](https://github.com/orgs/immich-app/projects/1)
- [Demo](#demo)
- [Funzionalità](#features)
- [Introduzione](https://immich.app/docs/overview/introduction)
- [Installazione](https://immich.app/docs/install/requirements)
- [Linee Guida per Contribuire](https://immich.app/docs/overview/support-the-project)

## Documentazione

La documentazione ufficiale, inclusa la guida all'installazione, è disponibile qui: https://immich.app/.

## Demo

Prova la demo del progetto https://demo.immich.app. Sull'app mobile, imposta `https://demo.immich.app` come `Server Endpoint URL`

```bash title="Demo Credential"
Credenziali di accesso
email: demo@immich.app
password: demo
```

# Funzionalità

| Funzionalità                                   | Mobile | Web |
| ---------------------------------------------- | ------ | --- |
| Caricamento e visualizzazione di foto e video  |   Sì   | Sì  |
| Backup automatico quando l'app è in esecuzione |   Sì   | N/D |
| Selezione degli album per backup               |   Sì   | N/D |
| Download foto e video sul dispositivo          |   Sì   | Sì  |
| Supporto multi utente                          |   Sì   | Sì  |
| Album e album condivisi                        |   Sì   | Sì  |
| Barra di scorrimento con trascinamento         |   Sì   | Sì  |
| Supporto formati raw                           |   Sì   | Sì  |
| Visualizzazione metadata (EXIF, map)           |   Sì   | Sì  |
| Ricerca per metadata, oggetti, volti e CLIP    |   Sì   | Sì  |
| Funzioni di amministrazione degli utenti       |   No   | Sì  |
| Backup in background                           |   Sì   | N/D |
| Scroll virtuale                                |   Sì   | Sì  |
| Supporto OAuth                                 |   Sì   | Sì  |
| API Keys                                       |  N/D   | Sì  |
| Backup e riproduzione di LivePhoto             |  iOS   | Sì  |
| Archiviazione impostata dall'utente            |   Sì   | Sì  |
| Condivisione pubblica                          |   No   | Sì  |
| Archivio e Preferiti                           |   Sì   | Sì  |
| Mappa globale                                  |   Sì   | Sì  |
| Collaborazione con utenti                      |   Sì   | Sì  |
| Riconoscimento facciale e categorizzazione     |   Sì   | Sì  |
| Ricordi (x anni fa)                            |   Sì   | Sì  |
| Supporto offline                               |   Sì   | No  |
| Galleria sola lettura                          |   Sì   | Sì  |
| Foto raggruppate                               |   Sì   | Sì  |
