<p align="center"> 
  <br/>  
  <a href="https://opensource.org/license/agpl-v3"><img src="https://img.shields.io/badge/License-AGPL_v3-blue.svg?color=3F51B5&style=for-the-badge&label=License&logoColor=000000&labelColor=ececec" alt="License: AGPLv3"></a>
  <a href="https://discord.immich.app">
    <img src="https://img.shields.io/discord/979116623879368755.svg?label=Discord&logo=Discord&style=for-the-badge&logoColor=000000&labelColor=ececec" atl="Discord"/>
  </a>
  <br/>  
  <br/>   
</p>

<p align="center">
<img src="../design/immich-logo-stacked-light.svg" width="300" title="Login met aangepaste URL">
</p>
<h3 align="center">Immich - Hoogwaardige, self-hosted back-up oplossing voor foto's en video's</h3>
<br/>
<a href="https://immich.app">
<img src="../design/immich-screenshots.png" title="Main Screenshot">
</a>
<br/>
<p align="center">
  <a href="../README.md">English</a>
  <a href="README_ca_ES.md">Català</a>
  <a href="README_es_ES.md">Español</a>
  <a href="README_fr_FR.md">Français</a>
  <a href="README_it_IT.md">Italiano</a>
  <a href="README_ja_JP.md">日本語</a>
  <a href="README_ko_KR.md">한국어</a>
  <a href="README_de_DE.md">Deutsch</a>
  <a href="README_tr_TR.md">Türkçe</a>
  <a href="README_zh_CN.md">中文</a>
  <a href="README_uk_UA.md">Українська</a>
  <a href="README_ru_RU.md">Русский</a>
  <a href="README_pt_BR.md">Português Brasileiro</a>
  <a href="README_sv_SE.md">Svenska</a>
  <a href="README_ar_JO.md">العربية</a>
  <a href="README_th_TH.md">ภาษาไทย</a>
</p>

## Disclaimer

- ⚠️ Het project wordt momenteel **zeer actief** ontwikkeld.
- ⚠️ Verwacht bugs en ingrijpende wijzigingen.
- ⚠️ **Gebruik de app niet als de enige manier om uw foto's en video's op te slaan.**
- ⚠️ Volg altijd het [3-2-1](https://www.backblaze.com/blog/the-3-2-1-backup-strategy/) backup plan voor je kostbare foto's en video's!

## Inhoud

- [Officiële documentatie](https://immich.app/docs)
- [Toekomstplannen](https://github.com/orgs/immich-app/projects/1)
- [Demo](#demo)
- [Functies](#functies)
- [Introductie](https://immich.app/docs/overview/introduction)
- [Installatie](https://immich.app/docs/install/requirements)
- [Richtlijnen voor bijdragen](https://immich.app/docs/overview/support-the-project)

## Documentatie

De belangrijkste documentatie, inclusief installatie handleidingen, zijn te vinden op https://immich.app/.

## Demo

Je kunt de demo [hier](https://demo.immich.app/) bekijken. Voor de mobiele app kun je gebruik maken van `https://demo.immich.app` voor de `Server Endpoint URL`.

### Login gegevens

| Email           | Wachtwoord |
| --------------- | ---------- |
| demo@immich.app | demo       |

# Functies

| Functies                                            | Mobiel | Web |
|-----------------------------------------------------|--------|-----|
| Upload en bekijk video's en foto's                  | Ja     | Ja  |
| Automatische back-up wanneer de app wordt geopend   | Ja     | NVT |
| Duplicatie van bestanden voorkomen                  | Ja     | Ja  |
| Selectieve album(s) voor back-up                    | Ja     | NVT |
| Download foto's en video's naar een lokaal apparaat | Ja     | Ja  |
| Ondersteuning voor meerdere gebruikers              | Ja     | Ja  |
| Album en gedeelde albums                            | Ja     | Ja  |
| Versleepbare scroll balk                            | Ja     | Ja  |
| Ondersteuning voor het RAW formaat                  | Ja     | Ja  |
| Metagegevensweergave (EXIF, kaart)                  | Ja     | Ja  |
| Zoek op metagegevens, objecten, gezichten en CLIP   | Ja     | Ja  |
| Administratieve functies (gebruikersbeheer)         | Nee    | Ja  |
| Back-up op de achtergrond                           | Ja     | NVT |
| Virtueel scrollen                                   | Ja     | Ja  |
| OAuth-ondersteuning                                 | Ja     | Ja  |
| API-sleutels                                        | NVT    | Ja  |
| LivePhoto-back-up en weergave                       | iOS    | Ja  |
| Ondersteuning 360 Graden foto weergave              | Nee    | Ja  |
| Door de gebruiker gedefinieerde opslagstructuur     | Ja     | Ja  |
| Openbaar delen                                      | Nee    | Ja  |
| Archief en Favorieten                               | Ja     | Ja  |
| Wereldkaart                                         | Ja     | Ja  |
| Delen met partner                                   | Ja     | Ja  |
| Gezichtsherkenning en groepering                    | Ja     | Ja  |
| Herinneringen (x jaar geleden)                      | Ja     | Ja  |
| Offline-ondersteuning                               | Ja     | Nee |
| Alleen-lezen galerij                                | Ja     | Ja  |
| Gestapelde foto's                                   | Ja     | Ja  |

## Vertalingen

Je kunt [hier](https://immich.app/docs/developer/translations) meer over vertalingen lezen.

## Repository activiteit

![Activities](https://repobeats.axiom.co/api/embed/9e86d9dc3ddd137161f2f6d2e758d7863b1789cb.svg "Repobeats analytics image")

## Ster geschiedenis

<a href="https://star-history.com/#immich-app/immich&Date">
 <picture>
   <source media="(prefers-color-scheme: dark)" srcset="https://api.star-history.com/svg?repos=immich-app/immich&type=Date&theme=dark" />
   <source media="(prefers-color-scheme: light)" srcset="https://api.star-history.com/svg?repos=immich-app/immich&type=Date" />
   <img alt="Star History Chart" src="https://api.star-history.com/svg?repos=immich-app/immich&type=Date" width="100%" />
 </picture>
</a>

## Contributie-leden

<a href="https://github.com/alextran1502/immich/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=immich-app/immich" width="100%"/>
</a>
