<p align="center"> 
  <br/>  
  <a href="https://opensource.org/license/agpl-v3"><img src="https://img.shields.io/badge/License-AGPL_v3-blue.svg?color=3F51B5&style=for-the-badge&label=License&logoColor=000000&labelColor=ececec" alt="License: AGPLv3"></a>
  <a href="https://discord.immich.app">
    <img src="https://img.shields.io/discord/979116623879368755.svg?label=Discord&logo=Discord&style=for-the-badge&logoColor=000000&labelColor=ececec" atl="Discord"/>
  </a>
  <br/>  
  <br/>   
</p>

<p align="center">
<img src="../design/immich-logo-stacked-light.svg" width="300" title="Login With Custom URL">
</p>
<h3 align="center">高性能的照片和视频自托管解决方案</h3>
<p align="center">  
请注意: 此 README 不是由 Immich 团队维护, 而是依靠贡献者来更新的，这意味着它可能并不会被及时更新。感谢理解。
</p>
<br/>
<a href="https://immich.app">
<img src="../design/immich-screenshots.png" title="界面截图">
</a>
<br/>
<p align="center">

  <a href="../README.md">English</a>
  <a href="README_ca_ES.md">Català</a>
  <a href="README_es_ES.md">Español</a>
  <a href="README_fr_FR.md">Français</a>
  <a href="README_it_IT.md">Italiano</a>
  <a href="README_ja_JP.md">日本語</a>
  <a href="README_ko_KR.md">한국어</a>
  <a href="README_de_DE.md">Deutsch</a>
  <a href="README_nl_NL.md">Nederlands</a>
  <a href="README_tr_TR.md">Türkçe</a>
  <a href="README_uk_UA.md">Українська</a>
  <a href="README_ru_RU.md">Русский</a>
  <a href="README_pt_BR.md">Português Brasileiro</a>
  <a href="README_sv_SE.md">Svenska</a>
  <a href="README_ar_JO.md">العربية</a>
  <a href="README_vi_VN.md">Tiếng Việt</a>
  <a href="README_th_TH.md">ภาษาไทย</a>

</p>

## 免责声明

- ⚠️ 本项目正在 **非常活跃** 地开发中。
- ⚠️ 可能存在 bug 或者随时有重大变更。
- ⚠️ **不要把本软件作为您存储照片或视频的唯一方式。**
- ⚠️ 为了您宝贵的照片与视频，请始终遵守 [3-2-1](https://www.backblaze.com/blog/the-3-2-1-backup-strategy/) 备份方案！

> [!NOTE]
> 完整的项目文档以及安装教程请参见：<https://immich.app/>。

## 目录

- [官方文档](https://immich.app/docs)
- [项目总览](https://immich.app/docs/overview/introduction)
- [安装教程](https://immich.app/docs/install/requirements)
- [路线图](https://immich.app/roadmap)
- [在线演示](#示例)
- [功能特性](#功能特性)
- [多语言](https://immich.app/docs/developer/translations)
- [贡献者](https://immich.app/docs/overview/support-the-project)

## 示例

您可以在[此处](https://demo.immich.app)访问在线演示网站。在移动端，您可以使用 `https://demo.immich.app` 作为 `服务终端链接`

### 登录认证信息

| 邮箱            | 密码     |
| --------------- | -------- |
| demo@immich.app | demo     |

## 功能特性

| 功能特性                                    | 移动端 | 网页端 |
| :------------------------------------------ | ------ | ------ |
| 上传并查看照片和视频                        | 是     | 是     |
| 软件运行时自动备份                          | 是     | N/A    |
| 忽略重复的项目                              | 是     | 是     |
| 选择需要备份的相册                          | 是     | N/A    |
| 下载照片和视频到本地                        | 是     | 是     |
| 多用户支持                                  | 是     | 是     |
| 相册与共享相册                              | 是     | 是     |
| 可拖动的快速滚动条                          | 是     | 是     |
| 支持RAW格式                                 | 是     | 是     |
| 元数据视图（EXIF、地图）                    | 是     | 是     |
| 通过元数据、对象、人脸和标签进行搜索        | 是     | 是     |
| 管理功能（用户管理）                        | 否     | 是     |
| 后台备份                                    | 是     | N/A    |
| 虚拟滚动                                    | 是     | 是     |
| OAuth 支持                                  | 是     | 是     |
| API Keys                                    | N/A    | 是     |
| 实况照片备份和查看                          | 是     | 是     |
| 支持360度全景图显示                         | 否     | 是     |
| 用户自定义存储结构                          | 是     | 是     |
| 公共分享                                    | 是     | 是     |
| 归档与收藏功能                              | 是     | 是     |
| 足迹地图                                    | 是     | 是     |
| 好友分享                                    | 是     | 是     |
| 人脸识别与分组                              | 是     | 是     |
| 回忆（那年今日）                            | 是     | 是     |
| 离线支持                                    | 是     | 否     |
| 只读相册                                    | 是     | 是     |
| 照片堆叠                                    | 是     | 是     |
| 标签                                        | 否     | 是     |
| 文件夹浏览                                  | 否     | 是     |

## 多语言

关于翻译的更多信息请参见[此处](https://immich.app/docs/developer/translations)。

<a href="https://hosted.weblate.org/engage/immich/">
<img src="https://hosted.weblate.org/widget/immich/immich/multi-auto.svg" alt="翻译进度" />
</a>

## 活跃度

![活跃度](https://repobeats.axiom.co/api/embed/9e86d9dc3ddd137161f2f6d2e758d7863b1789cb.svg "Repobeats analytics image")

## Star增长曲线

<a href="https://star-history.com/#immich-app/immich&Date">
 <picture>
   <source media="(prefers-color-scheme: dark)" srcset="https://api.star-history.com/svg?repos=immich-app/immich&type=Date&theme=dark" />
   <source media="(prefers-color-scheme: light)" srcset="https://api.star-history.com/svg?repos=immich-app/immich&type=Date" />
   <img alt="Star History Chart" src="https://api.star-history.com/svg?repos=immich-app/immich&type=Date" width="100%" />
 </picture>
</a>

## 贡献者

<a href="https://github.com/alextran1502/immich/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=immich-app/immich" width="100%"/>
</a>
